echo Building 3.0.y odroidx2_ubuntu_mali_defconfig...

echo Backing up current kernel...
mkdir backup/
mkdir backup/boot/
mkdir backup/rootfs/
mkdir backup/rootfs/boot/
mkdir backup/rootfs/lib/
mkdir backup/rootfs/lib/modules/
cp /media/boot/* backup/boot/
cp /boot/* backup/rootfs/boot/
cp -r /lib/modules/`uname -r | cat` backup/rootfs/lib/modules/

mkdir release/
mkdir release/odroidx2_ubuntu_mali_defconfig/
mkdir release/odroidx2_ubuntu_mali_defconfig/boot/
mkdir release/odroidx2_ubuntu_mali_defconfig/rootfs/
mkdir release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/

echo Cleaning build...
make mrproper
echo Creating config file...
make odroidx2_ubuntu_mali_defconfig
echo Making zImage and modules...
make -j5 zImage modules

echo Copying files to release directory...
cp arch/arm/boot/zImage release/odroidx2_ubuntu_mali_defconfig/boot
cp arch/arm/boot/zImage release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/vmlinuz-`cat include/config/kernel.release`

echo Making install...
make install

echo Making modules...
make modules_install

echo Compressing modules...
tar -cvzf release/odroidx2_ubuntu_mali_defconfig/rootfs/modules.tgz /lib/modules/`cat include/config/kernel.release`

echo Copying config files...
cp .config release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/config-`cat include/config/kernel.release`
cp .config /boot/config-`cat include/config/kernel.release`

echo Building uInitrd phase 1 of 2..
update-initramfs -c -k `cat include/config/kernel.release`

echo Building uInitrd phase 2 of 2..
mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 -n uInitrd -d /boot/initrd.img-`cat include/config/kernel.release` release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/uInitrd-`cat include/config/kernel.release`

echo Copying files and cleaning up..
cp release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/uInitrd-`cat include/config/kernel.release` release/odroidx2_ubuntu_mali_defconfig/boot/uInitrd
mv /boot/*-`cat include/config/kernel.release` release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/
cp System.map release/odroidx2_ubuntu_mali_defconfig/rootfs/boot/System.map-`cat include/config/kernel.release`
rm /media/boot/uImage

echo Copying installation script...
cp install.sh release/odroidx2_ubuntu_mali_defconfig/ && chmod +x release/odroidx2_ubuntu_mali_defconfig/install.sh

echo Restoring original /boot files...
cp backup/rootfs/boot/* /boot/
cp backup/boot/zImage /media/boot/zImage
cp backup/boot/uInitrd /media/boot/uInitrd

echo Restoring original modules...
rm -rf /lib/modules/`cat include/config/kernel.release`
cp -r backup/rootfs/lib/modules/* /lib/modules/
depmod -a

echo Release package contents:
ls -R release/odroidx2_ubuntu_mali_defconfig/
echo The kernel compilation for odroidx2_ubuntu_mali_defconfig is done!  The installation files are  in the release/odroidx2_ubuntu_mali_defconfig folder.
